#include <16F87.h>

#FUSES NOWDT      // No Watch Dog Timer 
#FUSES INTRC      // setup internal oscillator 
#FUSES NOMCLR       // Master Clear pin disabled 
#FUSES NOLVP      // No Low Voltage Programming on B3(PIC16) or B5(PIC18) 
#FUSES NOBROWNOUT  // No Brownout reset
//#FUSES CCPB3      //default is RB0 for CCPB switch to RB3

#use delay(internal=4MHz)

#define SND PIN_B3
#define LED PIN_B0

#define PRE   PIN_B1
#define PANIC PIN_B2

//odtwarzanie dzwieku o danej czestotliwosci
void play(int16 d){
      output_high(SND);
      delay_us(d);
      output_low(SND);
      delay_us(d);
}

//migniecie LED
void blink(int16 x){
      delay_ms(800);
      output_high(LED);
      delay_ms(x);
      output_low(LED);
}

//sygnal dzwiekowy "dziou"
void dziou(){
    for(int16 x=100; x<1000; x++){
        play(x);
    }
}

//sygnal dzwiekowy "uoudz"
void uoidz(){
    for(int16 x=1000; x>100; x--){
        play(x);
    }
}

//sygnal o czestotliwosci 22kHz
void sarna(){
   for (int x = 0; x<100; x++){
      play(1043);
   }
}

void main()
{
//   setup_timer_2(T2_DIV_BY_16,100,1);  
//   setup_ccp1(CCP_PWM);
//   set_pwm1_duty((int16)0);

output_low(SND);
//zerowanie wykrytych alarmow
char was_alarm = 0;

  while(true){
   
   //jesli byl wywolany alarm
   if (was_alarm==1){
      blink(400);
   }
   //stan czuwania, alarmu nie bylo
   else{
      blink(10);
   }
   
	//wywolanie pre alarmu
   if(input(PRE)==true){
	   was_alarm=1;
           sarna();
   }

   //wywolanie alarmu
   if(input(PANIC)==true){
       blink(900);
       was_alarm=1;
           for (int x=0; x<4; x++){
             //sekwencja dziou uoidz trwa 2,5 sekundy
             dziou();
             uoidz();
          }
   }
   
  }
  
}
